MyGUI: MyGUI::MenuControl Class Reference

MyGUI 3.2.2

Data Structures | Public Types | Public Member Functions | Static Public Member Functions | Data Fields | Protected Member Functions | Protected Attributes
MyGUI::MenuControl Class Reference

MenuControl properties.
Skin childs. MenuControl widget description should be here. More...

`#include <MyGUI_MenuControl.h>`

Inheritance diagram for MyGUI::MenuControl:
[legend]

## Data Structures
struct | ItemInfo

## Public Types
typedef RTTIBase | Base
typedef MenuControl | RTTIBase
typedef std::vector< ItemInfo > | VectorMenuItemInfo
Public Types inherited from MyGUI::Widget
typedef RTTIBase | Base
typedef Widget | RTTIBase
Public Types inherited from MyGUI::IObject
typedef IObject | RTTIBase

## Public Member Functions
virtual const std::string & | getTypeName () const
virtual bool | isType (const std::type_info &_type) const
template<typename Type >
bool | isType () const
| MenuControl ()
virtual void | setVisible (bool _value)
void | setVisibleSmooth (bool _value)
size_t | getItemCount () const
| Get number of items. More...
MenuItem * | insertItemAt (size_t _index, const UString &_name, MenuItemType _type=MenuItemType::Normal, const std::string &_id="", Any _data=Any::Null)
| Insert an item into a array at a specified position. More...
MenuItem * | insertItem (MenuItem *_to, const UString &_name, MenuItemType _type=MenuItemType::Normal, const std::string &_id="", Any _data=Any::Null)
| Insert an item into a array. More...
MenuItem * | addItem (const UString &_name, MenuItemType _type=MenuItemType::Normal, const std::string &_id="", Any _data=Any::Null)
| Add an item to the end of a array. More...
void | removeItemAt (size_t _index)
| Remove item at a specified position. More...
void | removeItem (MenuItem *_item)
| Remove item. More...
void | removeAllItems ()
| Remove all items. More...
MenuItem * | getItemAt (size_t _index)
| Get item from specified position. More...
size_t | getItemIndex (MenuItem *_item)
| Get item index. More...
size_t | findItemIndex (MenuItem *_item)
| Search item, returns the position of the first occurrence in array or ITEM_NONE if item not found. More...
MenuItem * | findItemWith (const UString &_name)
| Search item, returns the item of the first occurrence in array or nullptr if item not found. More...
void | setItemDataAt (size_t _index, Any _data)
| Replace an item data at a specified position. More...
void | setItemData (MenuItem *_item, Any _data)
| Replace an item data. More...
void | clearItemDataAt (size_t _index)
| Clear an item data at a specified position. More...
void | clearItemData (MenuItem *_item)
| Clear an item data. More...
template<typename ValueType >
ValueType * | getItemDataAt (size_t _index, bool _throw=true)
| Get item data from specified position. More...
template<typename ValueType >
ValueType * | getItemData (MenuItem *_item, bool _throw=true)
| Get item data. More...
void | setItemIdAt (size_t _index, const std::string &_id)
| Replace an item id at a specified position. More...
void | setItemId (MenuItem *_item, const std::string &_id)
| Replace an item id. More...
const std::string & | getItemIdAt (size_t _index)
| Get item id from specified position. More...
const std::string & | getItemId (MenuItem *_item)
| Get item id. More...
MenuItem * | getItemById (const std::string &_id)
MenuItem * | findItemById (const std::string &_id, bool _recursive=false)
size_t | getItemIndexById (const std::string &_id)
void | setItemNameAt (size_t _index, const UString &_name)
| Replace an item name at a specified position. More...
void | setItemName (MenuItem *_item, const UString &_name)
| Replace an item name. More...
const UString & | getItemNameAt (size_t _index)
| Get item from specified position. More...
const UString & | getItemName (MenuItem *_item)
| Get item from specified position. More...
size_t | findItemIndexWith (const UString &_name)
| Search item, returns the position of the first occurrence in array or ITEM_NONE if item not found. More...
void | setItemChildVisibleAt (size_t _index, bool _visible)
void | setItemChildVisible (MenuItem *_item, bool _visible)
template<typename Type >
Type * | createItemChildTAt (size_t _index)
template<typename Type >
Type * | createItemChildT (MenuItem *_item)
MenuControl * | getItemChildAt (size_t _index)
MenuControl * | getItemChild (MenuItem *_item)
MenuControl * | createItemChildAt (size_t _index)
MenuControl * | createItemChild (MenuItem *_item)
void | removeItemChildAt (size_t _index)
void | removeItemChild (MenuItem *_item)
MenuItemType | getItemTypeAt (size_t _index)
MenuItemType | getItemType (MenuItem *_item)
void | setItemTypeAt (size_t _index, MenuItemType _type)
void | setItemType (MenuItem *_item, MenuItemType _type)
void | setPopupAccept (bool _value)
bool | getPopupAccept () const
MenuItem * | getMenuItemParent ()
void | setVerticalAlignment (bool _value)
bool | getVerticalAlignment () const
void | _notifyDeleteItem (MenuItem *_item)
void | _notifyDeletePopup (MenuItem *_item)
void | _notifyUpdateName (MenuItem *_item)
void | _wrapItemChild (MenuItem *_item, MenuControl *_widget)
virtual size_t | _getItemCount ()
virtual void | _addItem (const MyGUI::UString &_name)
virtual void | _removeItemAt (size_t _index)
virtual Widget * | _getItemAt (size_t _index)
virtual void | _setItemNameAt (size_t _index, const UString &_name)
virtual const UString & | _getItemNameAt (size_t _index)
virtual void | _setItemSelected (IItem *_item)
void | _updateItems (size_t _index)
void | _updateSizeForEmpty ()
Public Member Functions inherited from MyGUI::Widget
template<typename Type >
bool | isType () const
| Widget ()
Widget * | createWidgetT (const std::string &_type, const std::string &_skin, const IntCoord &_coord, Align _align, const std::string &_name="")
Widget * | createWidgetT (const std::string &_type, const std::string &_skin, int _left, int _top, int _width, int _height, Align _align, const std::string &_name="")
Widget * | createWidgetRealT (const std::string &_type, const std::string &_skin, const FloatCoord &_coord, Align _align, const std::string &_name="")
Widget * | createWidgetRealT (const std::string &_type, const std::string &_skin, float _left, float _top, float _width, float _height, Align _align, const std::string &_name="")
template<typename T >
T * | createWidget (const std::string &_skin, const IntCoord &_coord, Align _align, const std::string &_name="")
template<typename T >
T * | createWidget (const std::string &_skin, int _left, int _top, int _width, int _height, Align _align, const std::string &_name="")
template<typename T >
T * | createWidgetReal (const std::string &_skin, const FloatCoord &_coord, Align _align, const std::string &_name="")
template<typename T >
T * | createWidgetReal (const std::string &_skin, float _left, float _top, float _width, float _height, Align _align, const std::string &_name="")
Widget * | createWidgetT (WidgetStyle _style, const std::string &_type, const std::string &_skin, const IntCoord &_coord, Align _align, const std::string &_layer="", const std::string &_name="")
template<typename T >
T * | createWidget (WidgetStyle _style, const std::string &_skin, const IntCoord &_coord, Align _align, const std::string &_layer="", const std::string &_name="")
virtual void | setPosition (const IntPoint &_value)
virtual void | setSize (const IntSize &_value)
virtual void | setCoord (const IntCoord &_value)
void | setPosition (int _left, int _top)
void | setSize (int _width, int _height)
void | setCoord (int _left, int _top, int _width, int _height)
void | setRealPosition (const FloatPoint &_value)
void | setRealSize (const FloatSize &_value)
void | setRealCoord (const FloatCoord &_value)
void | setRealPosition (float _left, float _top)
void | setRealSize (float _width, float _height)
void | setRealCoord (float _left, float _top, float _width, float _height)
const std::string & | getName () const
| Get name of widget. More...
bool | getVisible () const
void | setDepth (int _value)
int | getDepth () const
bool | getInheritedVisible () const
virtual void | setAlign (Align _value)
Align | getAlign () const
void | setAlpha (float _value)
float | getAlpha () const
void | setInheritsAlpha (bool _value)
bool | getInheritsAlpha () const
void | setColour (const Colour &_value)
bool | isRootWidget () const
Widget * | getParent () const
IntSize | getParentSize () const
EnumeratorWidgetPtr | getEnumerator () const
size_t | getChildCount ()
Widget * | getChildAt (size_t _index)
Widget * | findWidget (const std::string &_name)
void | findWidgets (const std::string &_name, VectorWidgetPtr &_result)
virtual void | setEnabled (bool _value)
void | setEnabledSilent (bool _value)
bool | getEnabled () const
bool | getInheritedEnabled () const
IntCoord | getClientCoord ()
Widget * | getClientWidget ()
void | detachFromWidget (const std::string &_layer="")
void | attachToWidget (Widget *_parent, WidgetStyle _style=WidgetStyle::Child, const std::string &_layer="")
void | changeWidgetSkin (const std::string &_skinName)
void | setWidgetStyle (WidgetStyle _style, const std::string &_layer="")
WidgetStyle | getWidgetStyle () const
void | setProperty (const std::string &_key, const std::string &_value)
virtual size_t | _getItemIndex (Widget *_item)
void | _forcePick (Widget *_widget)
void | _initialise (WidgetStyle _style, const IntCoord &_coord, const std::string &_skinName, Widget *_parent, ICroppedRectangle *_croppedParent, const std::string &_name)
void | _shutdown ()
void | _destroyChildWidget (Widget *_widget)
void | _setContainer (Widget *_value)
Widget * | _getContainer ()
void | _setAlign (const IntSize &_oldsize, const IntSize &_newSize)
bool | _checkPoint (int _left, int _top) const
Widget * | _createSkinWidget (WidgetStyle _style, const std::string &_type, const std::string &_skin, const IntCoord &_coord, Align _align, const std::string &_layer="", const std::string &_name="")
virtual void | _resetContainer (bool _update)
bool | _setWidgetState (const std::string &_value)
void | _updateChilds ()
Public Member Functions inherited from MyGUI::IObject
template<typename Type >
bool | isType () const
template<typename Type >
Type * | castType (bool _throw=true)
template<typename Type >
const Type * | castType (bool _throw=true) const
| IObject ()
virtual | ~IObject ()
Public Member Functions inherited from MyGUI::ICroppedRectangle
| ICroppedRectangle ()
virtual | ~ICroppedRectangle ()
ICroppedRectangle * | getCroppedParent ()
IntPoint | getPosition () const
IntSize | getSize () const
const IntCoord & | getCoord () const
const IntPoint & | getAbsolutePosition () const
IntRect | getAbsoluteRect () const
IntCoord | getAbsoluteCoord () const
int | getAbsoluteLeft () const
int | getAbsoluteTop () const
int | getLeft () const
int | getRight () const
int | getTop () const
int | getBottom () const
int | getWidth () const
int | getHeight () const
bool | _isMargin () const
int | _getViewLeft () const
int | _getViewRight () const
int | _getViewTop () const
int | _getViewBottom () const
int | _getViewWidth () const
int | _getViewHeight () const
void | _setCroppedParent (ICroppedRectangle *_parent)
const IntRect & | _getMargin () const
int | _getMarginLeft () const
int | _getMarginRight () const
int | _getMarginTop () const
int | _getMarginBottom () const
Public Member Functions inherited from MyGUI::UserData
| UserData ()
virtual | ~UserData ()
void | setUserString (const std::string &_key, const std::string &_value)
const std::string & | getUserString (const std::string &_key) const
const MapString & | getUserStrings () const
bool | clearUserString (const std::string &_key)
bool | isUserString (const std::string &_key) const
void | clearUserStrings ()
void | setUserData (Any _data)
template<typename ValueType >
ValueType * | getUserData (bool _throw=true) const
void | _setInternalData (Any _data)
template<typename ValueType >
ValueType * | _getInternalData (bool _throw=true) const
Public Member Functions inherited from MyGUI::WidgetInput
| WidgetInput ()
virtual | ~WidgetInput ()
void | setNeedToolTip (bool _value)
bool | getNeedToolTip () const
void | setPointer (const std::string &_value)
const std::string & | getPointer () const
void | setNeedKeyFocus (bool _value)
bool | getNeedKeyFocus () const
void | setNeedMouseFocus (bool _value)
bool | getNeedMouseFocus () const
void | setInheritsPick (bool _value)
bool | getInheritsPick () const
void | setMaskPick (const std::string &_filename)
void | setMaskPick (const MaskPickInfo &_info)
bool | isMaskPickInside (const IntPoint &_point, const IntCoord &_coord) const
bool | getRootMouseFocus () const
bool | getRootKeyFocus () const
void | _riseMouseLostFocus (Widget *_new)
void | _riseMouseSetFocus (Widget *_old)
void | _riseMouseDrag (int _left, int _top, MouseButton _id)
void | _riseMouseMove (int _left, int _top)
void | _riseMouseWheel (int _rel)
void | _riseMouseButtonPressed (int _left, int _top, MouseButton _id)
void | _riseMouseButtonReleased (int _left, int _top, MouseButton _id)
void | _riseMouseButtonClick ()
void | _riseMouseButtonDoubleClick ()
void | _riseKeyLostFocus (Widget *_new)
void | _riseKeySetFocus (Widget *_old)
void | _riseKeyButtonPressed (KeyCode _key, Char _char)
void | _riseKeyButtonReleased (KeyCode _key)
void | _riseMouseChangeRootFocus (bool _focus)
void | _riseKeyChangeRootFocus (bool _focus)
void | _setRootMouseFocus (bool _value)
void | _setRootKeyFocus (bool _value)
Public Member Functions inherited from MyGUI::delegates::IDelegateUnlink
virtual | ~IDelegateUnlink ()
| IDelegateUnlink ()
bool | compare (IDelegateUnlink *_unlink) const
Public Member Functions inherited from MyGUI::SkinItem
| SkinItem ()
ISubWidgetText * | getSubWidgetText ()
ISubWidgetRect * | getSubWidgetMain ()
void | _setTextureName (const std::string &_texture)
const std::string & | _getTextureName () const
Public Member Functions inherited from MyGUI::LayerItem
| LayerItem ()
virtual | ~LayerItem ()
ILayer * | getLayer () const
ILayerNode * | getLayerNode () const
virtual void | attachItemToNode (ILayer *_layer, ILayerNode *_node)
virtual void | detachFromLayer ()
virtual void | upLayerItem ()
void | setRenderItemTexture (ITexture *_texture)
void | addChildItem (LayerItem *_item)
void | removeChildItem (LayerItem *_item)
void | addChildNode (LayerItem *_item)
void | removeChildNode (LayerItem *_item)
void | addRenderItem (ISubWidget *_item)
void | removeAllRenderItems ()
void | saveLayerItem ()
void | restoreLayerItem ()
Public Member Functions inherited from MyGUI::ILayerItem
virtual | ~ILayerItem ()
Public Member Functions inherited from MyGUI::MemberObsolete< Widget >
bool | isEnabled ()
bool | isInheritsAlpha ()
bool | isNeedKeyFocus ()
bool | isNeedMouseFocus ()
bool | isInheritsPick ()
bool | isVisible ()
Public Member Functions inherited from MyGUI::IItemContainer
| IItemContainer ()
virtual | ~IItemContainer ()
Public Member Functions inherited from MyGUI::MemberObsolete< MenuControl >
void | showMenu ()
void | hideMenu ()
bool | isShowMenu ()
void | showItemChildAt (size_t _index)
void | showItemChild (MenuItem *_item)
void | hideItemChildAt (size_t _index)
void | hideItemChild (MenuItem *_item)
void | setAlignVert (bool _value)
bool | getAlignVert ()

## Static Public Member Functions
static const std::string & | getClassTypeName ()
Static Public Member Functions inherited from MyGUI::Widget
static const std::string & | getClassTypeName ()
Static Public Member Functions inherited from MyGUI::IObject
static const std::string & | getClassTypeName ()

## Data Fields
EventHandle_MenuCtrlPtrMenuItemPtr | eventMenuCtrlAccept
EventHandle_MenuCtrlPtr | eventMenuCtrlClose
Data Fields inherited from MyGUI::Widget
EventHandle_WidgetStringString | eventChangeProperty
EventHandle_WidgetVoid | eventChangeCoord
Data Fields inherited from MyGUI::WidgetInput
EventHandle_WidgetWidget | eventMouseLostFocus
EventHandle_WidgetWidget | eventMouseSetFocus
EventPairAddParameter< EventHandle_WidgetIntInt, EventHandle_WidgetIntIntButton > | eventMouseDrag
EventHandle_WidgetIntInt | eventMouseMove
EventHandle_WidgetInt | eventMouseWheel
EventHandle_WidgetIntIntButton | eventMouseButtonPressed
EventHandle_WidgetIntIntButton | eventMouseButtonReleased
EventHandle_WidgetVoid | eventMouseButtonClick
EventHandle_WidgetVoid | eventMouseButtonDoubleClick
EventHandle_WidgetWidget | eventKeyLostFocus
EventHandle_WidgetWidget | eventKeySetFocus
EventHandle_WidgetKeyCodeChar | eventKeyButtonPressed
EventHandle_WidgetKeyCode | eventKeyButtonReleased
EventHandle_WidgetBool | eventRootMouseChangeFocus
EventHandle_WidgetBool | eventRootKeyChangeFocus
EventHandle_WidgetToolTip | eventToolTip

## Protected Member Functions
virtual void | initialiseOverride ()
virtual void | shutdownOverride ()
virtual void | onKeyChangeRootFocus (bool _focus)
virtual void | onWidgetCreated (Widget *_widget)
virtual void | setPropertyOverride (const std::string &_key, const std::string &_value)
Protected Member Functions inherited from MyGUI::Widget
virtual | ~Widget ()
void | _updateView ()
Widget * | baseCreateWidget (WidgetStyle _style, const std::string &_type, const std::string &_skin, const IntCoord &_coord, Align _align, const std::string &_layer, const std::string &_name, bool _template)
void | _destroyAllChildWidget ()
virtual size_t | _getContainerIndex (const IntPoint &_point)
virtual void | baseUpdateEnable ()
virtual ILayerItem * | getLayerItemByPoint (int _left, int _top) const
virtual const IntCoord & | getLayerItemCoord () const
template<typename T >
void | assignWidget (T *&_widget, const std::string &_name)
VectorWidgetPtr | getSkinWidgetsByName (const std::string &_name)
void | destroySkinWidget (Widget *_widget)
virtual void | onWidgetDestroy (Widget *_widget)
void | setWidgetClient (Widget *_widget)
Protected Member Functions inherited from MyGUI::ICroppedRectangle
bool | _checkMargin ()
bool | _checkOutside () const
Protected Member Functions inherited from MyGUI::WidgetInput
virtual void | onMouseLostFocus (Widget *_new)
virtual void | onMouseSetFocus (Widget *_old)
virtual void | onMouseDrag (int _left, int _top, MouseButton _id)
virtual void | onMouseMove (int _left, int _top)
virtual void | onMouseWheel (int _rel)
virtual void | onMouseButtonPressed (int _left, int _top, MouseButton _id)
virtual void | onMouseButtonReleased (int _left, int _top, MouseButton _id)
virtual void | onMouseButtonClick ()
virtual void | onMouseButtonDoubleClick ()
virtual void | onKeyLostFocus (Widget *_new)
virtual void | onKeySetFocus (Widget *_old)
virtual void | onKeyButtonPressed (KeyCode _key, Char _char)
virtual void | onKeyButtonReleased (KeyCode _key)
virtual void | onMouseChangeRootFocus (bool _focus)
Protected Member Functions inherited from MyGUI::SkinItem
void | _createSkinItem (ResourceSkin *_info)
void | _deleteSkinItem ()
void | _setSkinItemAlign (const IntSize &_size)
void | _setSkinItemVisible (bool _value)
void | _setSkinItemColour (const Colour &_value)
void | _setSkinItemAlpha (float _value)
void | _correctSkinItemView ()
void | _updateSkinItemView ()
bool | _setSkinItemState (const std::string &_state)
void | _setSubSkinVisible (bool _visible)
Protected Member Functions inherited from MyGUI::LayerItem
void | attachToLayerItemNode (ILayerNode *_node, bool _deep)
void | detachFromLayerItemNode (bool _deep)

## Protected Attributes
bool | mHideByAccept
bool | mMenuDropMode
bool | mIsMenuDrop
bool | mHideByLostKey
bool | mResizeToContent
Protected Attributes inherited from MyGUI::ICroppedRectangle
IntRect | mMargin
IntCoord | mCoord
IntPoint | mAbsolutePosition
bool | mIsMargin
ICroppedRectangle * | mCroppedParent

## Detailed Description

MenuControl properties.
Skin childs. MenuControl widget description should be here.

Definition at line 30 of file MyGUI_MenuControl.h.

## Member Typedef Documentation

## ◆ Base

typedef RTTIBase MyGUI::MenuControl::Base

Definition at line 35 of file MyGUI_MenuControl.h.

## ◆ RTTIBase

typedef MenuControl MyGUI::MenuControl::RTTIBase

Definition at line 35 of file MyGUI_MenuControl.h.

## ◆ VectorMenuItemInfo

typedef std::vector<ItemInfo> MyGUI::MenuControl::VectorMenuItemInfo

Definition at line 69 of file MyGUI_MenuControl.h.

## Constructor & Destructor Documentation

## ◆ MenuControl()

MyGUI::MenuControl::MenuControl | ( |  | ) |

Definition at line 25 of file MyGUI_MenuControl.cpp.

## Member Function Documentation

## ◆ _addItem()

void MyGUI::MenuControl::_addItem | ( | const MyGUI::UString & | _name | ) |
| virtual

Reimplemented from MyGUI::IItemContainer.

Definition at line 818 of file MyGUI_MenuControl.cpp.

## ◆ _getItemAt()

Widget * MyGUI::MenuControl::_getItemAt | ( | size_t | _index | ) |
| virtual

Reimplemented from MyGUI::IItemContainer.

Definition at line 830 of file MyGUI_MenuControl.cpp.

## ◆ _getItemCount()

size_t MyGUI::MenuControl::_getItemCount | ( |  | ) |
| virtual

Reimplemented from MyGUI::IItemContainer.

Definition at line 813 of file MyGUI_MenuControl.cpp.

## ◆ _getItemNameAt()

const UString & MyGUI::MenuControl::_getItemNameAt | ( | size_t | _index | ) |
| virtual

Reimplemented from MyGUI::IItemContainer.

Definition at line 840 of file MyGUI_MenuControl.cpp.

## ◆ _notifyDeleteItem()

void MyGUI::MenuControl::_notifyDeleteItem | ( | MenuItem * | _item | ) |

Definition at line 258 of file MyGUI_MenuControl.cpp.

## ◆ _notifyDeletePopup()

void MyGUI::MenuControl::_notifyDeletePopup | ( | MenuItem * | _item | ) |

Definition at line 273 of file MyGUI_MenuControl.cpp.

## ◆ _notifyUpdateName()

void MyGUI::MenuControl::_notifyUpdateName | ( | MenuItem * | _item | ) |

Definition at line 279 of file MyGUI_MenuControl.cpp.

## ◆ _removeItemAt()

void MyGUI::MenuControl::_removeItemAt | ( | size_t | _index | ) |
| virtual

Reimplemented from MyGUI::IItemContainer.

Definition at line 823 of file MyGUI_MenuControl.cpp.

## ◆ _setItemNameAt()

void MyGUI::MenuControl::_setItemNameAt | ( | size_t | _index,
|  | const UString & | _name
| ) |  |
| virtual

Reimplemented from MyGUI::IItemContainer.

Definition at line 835 of file MyGUI_MenuControl.cpp.

## ◆ _setItemSelected()

void MyGUI::MenuControl::_setItemSelected | ( | IItem * | _item | ) |
| virtual

Reimplemented from MyGUI::IItemContainer.

Definition at line 845 of file MyGUI_MenuControl.cpp.

## ◆ _updateItems()

void MyGUI::MenuControl::_updateItems | ( | size_t | _index | ) |

Definition at line 870 of file MyGUI_MenuControl.cpp.

## ◆ _updateSizeForEmpty()

void MyGUI::MenuControl::_updateSizeForEmpty | ( |  | ) |

Definition at line 876 of file MyGUI_MenuControl.cpp.

## ◆ _wrapItemChild()

void MyGUI::MenuControl::_wrapItemChild | ( | MenuItem * | _item,
|  | MenuControl * | _widget
| ) |  |

Definition at line 493 of file MyGUI_MenuControl.cpp.

## ◆ addItem()

MenuItem * MyGUI::MenuControl::addItem | ( | const UString & | _name,
|  | MenuItemType | _type = `MenuItemType::Normal`,
|  | const std::string & | _id = `""`,
|  | Any | _data = `Any::Null`
| ) |  |

Add an item to the end of a array.

Definition at line 600 of file MyGUI_MenuControl.cpp.

## ◆ clearItemData()

void MyGUI::MenuControl::clearItemData | ( | MenuItem * | _item | ) |

Clear an item data.

Definition at line 713 of file MyGUI_MenuControl.cpp.

## ◆ clearItemDataAt()

void MyGUI::MenuControl::clearItemDataAt | ( | size_t | _index | ) |

Clear an item data at a specified position.

Definition at line 708 of file MyGUI_MenuControl.cpp.

## ◆ createItemChild()

MenuControl * MyGUI::MenuControl::createItemChild | ( | MenuItem * | _item | ) |

Create child item (submenu) for item

Definition at line 753 of file MyGUI_MenuControl.cpp.

## ◆ createItemChildAt()

MenuControl * MyGUI::MenuControl::createItemChildAt | ( | size_t | _index | ) |

Create child item (submenu) for item by index

Definition at line 748 of file MyGUI_MenuControl.cpp.

## ◆ createItemChildT()

template<typename Type >

Type* MyGUI::MenuControl::createItemChildT | ( | MenuItem * | _item | ) |
| inline

Create specific type child item (submenu) for item

Definition at line 191 of file MyGUI_MenuControl.h.

## ◆ createItemChildTAt()

template<typename Type >

Type* MyGUI::MenuControl::createItemChildTAt | ( | size_t | _index | ) |
| inline

Create specific type child item (submenu) for item by index

Definition at line 184 of file MyGUI_MenuControl.h.

## ◆ findItemById()

MenuItem * MyGUI::MenuControl::findItemById | ( | const std::string & | _id,
|  | bool | _recursive = `false`
| ) |  |

Find item by id

Definition at line 656 of file MyGUI_MenuControl.cpp.

## ◆ findItemIndex()

size_t MyGUI::MenuControl::findItemIndex | ( | MenuItem * | _item | ) |

Search item, returns the position of the first occurrence in array or ITEM_NONE if item not found.

Definition at line 683 of file MyGUI_MenuControl.cpp.

## ◆ findItemIndexWith()

size_t MyGUI::MenuControl::findItemIndexWith | ( | const UString & | _name | ) |

Search item, returns the position of the first occurrence in array or ITEM_NONE if item not found.

Definition at line 673 of file MyGUI_MenuControl.cpp.

## ◆ findItemWith()

MenuItem * MyGUI::MenuControl::findItemWith | ( | const UString & | _name | ) |

Search item, returns the item of the first occurrence in array or nullptr if item not found.

Definition at line 626 of file MyGUI_MenuControl.cpp.

## ◆ getClassTypeName()

static const std::string& MyGUI::MenuControl::getClassTypeName | ( |  | ) |
| inlinestatic

Definition at line 35 of file MyGUI_MenuControl.h.

## ◆ getItemAt()

MenuItem * MyGUI::MenuControl::getItemAt | ( | size_t | _index | ) |

Get item from specified position.

Definition at line 610 of file MyGUI_MenuControl.cpp.

## ◆ getItemById()

MenuItem * MyGUI::MenuControl::getItemById | ( | const std::string & | _id | ) |

Get item by id

Definition at line 636 of file MyGUI_MenuControl.cpp.

## ◆ getItemChild()

MenuControl * MyGUI::MenuControl::getItemChild | ( | MenuItem * | _item | ) |

Get child item (submenu) from item

Definition at line 743 of file MyGUI_MenuControl.cpp.

## ◆ getItemChildAt()

MenuControl * MyGUI::MenuControl::getItemChildAt | ( | size_t | _index | ) |

Get child item (submenu) from item by index

Definition at line 216 of file MyGUI_MenuControl.cpp.

## ◆ getItemCount()

size_t MyGUI::MenuControl::getItemCount | ( |  | ) | const

Get number of items.

Definition at line 698 of file MyGUI_MenuControl.cpp.

## ◆ getItemData()

template<typename ValueType >

ValueType* MyGUI::MenuControl::getItemData | ( | MenuItem * | _item,
|  | bool | _throw = `true`
| ) |  |
| inline

Get item data.

Definition at line 135 of file MyGUI_MenuControl.h.

## ◆ getItemDataAt()

template<typename ValueType >

ValueType* MyGUI::MenuControl::getItemDataAt | ( | size_t | _index,
|  | bool | _throw = `true`
| ) |  |
| inline

Get item data from specified position.

Definition at line 128 of file MyGUI_MenuControl.h.

## ◆ getItemId()

const std::string & MyGUI::MenuControl::getItemId | ( | MenuItem * | _item | ) |

Get item id.

Definition at line 723 of file MyGUI_MenuControl.cpp.

## ◆ getItemIdAt()

const std::string & MyGUI::MenuControl::getItemIdAt | ( | size_t | _index | ) |

Get item id from specified position.

Definition at line 252 of file MyGUI_MenuControl.cpp.

## ◆ getItemIndex()

size_t MyGUI::MenuControl::getItemIndex | ( | MenuItem * | _item | ) |

Get item index.

Definition at line 616 of file MyGUI_MenuControl.cpp.

## ◆ getItemIndexById()

size_t MyGUI::MenuControl::getItemIndexById | ( | const std::string & | _id | ) |

Get item index by id

Definition at line 646 of file MyGUI_MenuControl.cpp.

## ◆ getItemName()

const UString & MyGUI::MenuControl::getItemName | ( | MenuItem * | _item | ) |

Get item from specified position.

Definition at line 733 of file MyGUI_MenuControl.cpp.

## ◆ getItemNameAt()

const UString & MyGUI::MenuControl::getItemNameAt | ( | size_t | _index | ) |

Get item from specified position.

Definition at line 161 of file MyGUI_MenuControl.cpp.

## ◆ getItemType()

MenuItemType MyGUI::MenuControl::getItemType | ( | MenuItem * | _item | ) |

Get item type (see MenuItemType) from item

Definition at line 763 of file MyGUI_MenuControl.cpp.

## ◆ getItemTypeAt()

MenuItemType MyGUI::MenuControl::getItemTypeAt | ( | size_t | _index | ) |

Get item type (see MenuItemType) from item by index

Definition at line 289 of file MyGUI_MenuControl.cpp.

## ◆ getMenuItemParent()

MenuItem * MyGUI::MenuControl::getMenuItemParent | ( |  | ) |

Get parent menu item or nullptr if no item

Definition at line 783 of file MyGUI_MenuControl.cpp.

## ◆ getPopupAccept()

bool MyGUI::MenuControl::getPopupAccept | ( |  | ) | const

Get mode when clicking on item with submenu generate eventMenuCtrlAccept and closes menu

Definition at line 778 of file MyGUI_MenuControl.cpp.

## ◆ getTypeName()

virtual const std::string& MyGUI::MenuControl::getTypeName | ( |  | ) | const
| inlinevirtual

Get type name as string

Reimplemented from MyGUI::Widget.

Reimplemented in MyGUI::MenuBar, and MyGUI::PopupMenu.

Definition at line 35 of file MyGUI_MenuControl.h.

## ◆ getVerticalAlignment()

bool MyGUI::MenuControl::getVerticalAlignment | ( |  | ) | const

Get vertical alignment mode flag

Definition at line 889 of file MyGUI_MenuControl.cpp.

## ◆ initialiseOverride()

void MyGUI::MenuControl::initialiseOverride | ( |  | ) |
| protectedvirtual

skin clilds:
  Client is child widget with type Widget. Клиентская зона.

Reimplemented from MyGUI::Widget.

Definition at line 43 of file MyGUI_MenuControl.cpp.

## ◆ insertItem()

MenuItem * MyGUI::MenuControl::insertItem | ( | MenuItem * | _to,
|  | const UString & | _name,
|  | MenuItemType | _type = `MenuItemType::Normal`,
|  | const std::string & | _id = `""`,
|  | Any | _data = `Any::Null`
| ) |  |

Insert an item into a array.

Definition at line 595 of file MyGUI_MenuControl.cpp.

## ◆ insertItemAt()

MenuItem * MyGUI::MenuControl::insertItemAt | ( | size_t | _index,
|  | const UString & | _name,
|  | MenuItemType | _type = `MenuItemType::Normal`,
|  | const std::string & | _id = `""`,
|  | Any | _data = `Any::Null`
| ) |  |

Insert an item into a array at a specified position.

Definition at line 123 of file MyGUI_MenuControl.cpp.

## ◆ isType() [1/2]

template<typename Type >

bool MyGUI::MenuControl::isType | ( |  | ) | const
| inline

Compare with selected type

Definition at line 35 of file MyGUI_MenuControl.h.

## ◆ isType() [2/2]

virtual bool MyGUI::MenuControl::isType | ( | const std::type_info & | _type | ) | const
| inlinevirtual

Compare with selected type

Reimplemented from MyGUI::Widget.

Reimplemented in MyGUI::MenuBar, and MyGUI::PopupMenu.

Definition at line 35 of file MyGUI_MenuControl.h.

## ◆ onKeyChangeRootFocus()

void MyGUI::MenuControl::onKeyChangeRootFocus | ( | bool | _focus | ) |
| protectedvirtual

Reimplemented from MyGUI::WidgetInput.

Definition at line 474 of file MyGUI_MenuControl.cpp.

## ◆ onWidgetCreated()

void MyGUI::MenuControl::onWidgetCreated | ( | Widget * | _widget | ) |
| protectedvirtual

Reimplemented from MyGUI::Widget.

Definition at line 112 of file MyGUI_MenuControl.cpp.

## ◆ removeAllItems()

void MyGUI::MenuControl::removeAllItems | ( |  | ) |

Remove all items.

Definition at line 148 of file MyGUI_MenuControl.cpp.

## ◆ removeItem()

void MyGUI::MenuControl::removeItem | ( | MenuItem * | _item | ) |

Remove item.

Definition at line 605 of file MyGUI_MenuControl.cpp.

## ◆ removeItemAt()

void MyGUI::MenuControl::removeItemAt | ( | size_t | _index | ) |

Remove item at a specified position.

Definition at line 136 of file MyGUI_MenuControl.cpp.

## ◆ removeItemChild()

void MyGUI::MenuControl::removeItemChild | ( | MenuItem * | _item | ) |

Remove child item (submenu) for item

Definition at line 758 of file MyGUI_MenuControl.cpp.

## ◆ removeItemChildAt()

void MyGUI::MenuControl::removeItemChildAt | ( | size_t | _index | ) |

Remove child item (submenu) for item by index

Definition at line 222 of file MyGUI_MenuControl.cpp.

## ◆ setItemChildVisible()

void MyGUI::MenuControl::setItemChildVisible | ( | MenuItem * | _item,
|  | bool | _visible
| ) |  |

Show or hide item (submenu)

Definition at line 738 of file MyGUI_MenuControl.cpp.

## ◆ setItemChildVisibleAt()

void MyGUI::MenuControl::setItemChildVisibleAt | ( | size_t | _index,
|  | bool | _visible
| ) |  |

Show or hide item (submenu) at a specified position

Definition at line 340 of file MyGUI_MenuControl.cpp.

## ◆ setItemData()

void MyGUI::MenuControl::setItemData | ( | MenuItem * | _item,
|  | Any | _data
| ) |  |

Replace an item data.

Definition at line 703 of file MyGUI_MenuControl.cpp.

## ◆ setItemDataAt()

void MyGUI::MenuControl::setItemDataAt | ( | size_t | _index,
|  | Any | _data
| ) |  |

Replace an item data at a specified position.

Definition at line 210 of file MyGUI_MenuControl.cpp.

## ◆ setItemId()

void MyGUI::MenuControl::setItemId | ( | MenuItem * | _item,
|  | const std::string & | _id
| ) |  |

Replace an item id.

Definition at line 718 of file MyGUI_MenuControl.cpp.

## ◆ setItemIdAt()

void MyGUI::MenuControl::setItemIdAt | ( | size_t | _index,
|  | const std::string & | _id
| ) |  |

Replace an item id at a specified position.

Definition at line 246 of file MyGUI_MenuControl.cpp.

## ◆ setItemName()

void MyGUI::MenuControl::setItemName | ( | MenuItem * | _item,
|  | const UString & | _name
| ) |  |

Replace an item name.

Definition at line 728 of file MyGUI_MenuControl.cpp.

## ◆ setItemNameAt()

void MyGUI::MenuControl::setItemNameAt | ( | size_t | _index,
|  | const UString & | _name
| ) |  |

Replace an item name at a specified position.

Definition at line 235 of file MyGUI_MenuControl.cpp.

## ◆ setItemType()

void MyGUI::MenuControl::setItemType | ( | MenuItem * | _item,
|  | MenuItemType | _type
| ) |  |

Set item type (see MenuItemType) from item

Definition at line 768 of file MyGUI_MenuControl.cpp.

## ◆ setItemTypeAt()

void MyGUI::MenuControl::setItemTypeAt | ( | size_t | _index,
|  | MenuItemType | _type
| ) |  |

Set item type (see MenuItemType) from item by index

Definition at line 295 of file MyGUI_MenuControl.cpp.

## ◆ setPopupAccept()

void MyGUI::MenuControl::setPopupAccept | ( | bool | _value | ) |

Set mode when clicking on item with submenu generate eventMenuCtrlAccept and closes menu

Definition at line 773 of file MyGUI_MenuControl.cpp.

## ◆ setPropertyOverride()

void MyGUI::MenuControl::setPropertyOverride | ( | const std::string & | _key,
|  | const std::string & | _value
| ) |  |
| protectedvirtual

Properties:
  VerticalAlignment is MenuControl property with type bool.
  Вертикальное выравнивание.

Reimplemented from MyGUI::Widget.

Definition at line 894 of file MyGUI_MenuControl.cpp.

## ◆ setVerticalAlignment()

void MyGUI::MenuControl::setVerticalAlignment | ( | bool | _value | ) |

Set vertical alignment mode

Definition at line 882 of file MyGUI_MenuControl.cpp.

## ◆ setVisible()

void MyGUI::MenuControl::setVisible | ( | bool | _value | ) |
| virtual

Hide or show widget

Reimplemented from MyGUI::Widget.

Definition at line 534 of file MyGUI_MenuControl.cpp.

## ◆ setVisibleSmooth()

void MyGUI::MenuControl::setVisibleSmooth | ( | bool | _value | ) |

Hide or show Menu smooth

Definition at line 555 of file MyGUI_MenuControl.cpp.

## ◆ shutdownOverride()

void MyGUI::MenuControl::shutdownOverride | ( |  | ) |
| protectedvirtual

Reimplemented from MyGUI::Widget.

Definition at line 102 of file MyGUI_MenuControl.cpp.

## Field Documentation

## ◆ eventMenuCtrlAccept

EventHandle_MenuCtrlPtrMenuItemPtr MyGUI::MenuControl::eventMenuCtrlAccept

Event : Enter pressed or mouse clicked.
signature : void method(MyGUI::MenuControl* _sender, MyGUI::MenuItem* _item)

Parameters

  _sender | widget that called this event
  _item | Selected item

Definition at line 246 of file MyGUI_MenuControl.h.

## ◆ eventMenuCtrlClose

EventHandle_MenuCtrlPtr MyGUI::MenuControl::eventMenuCtrlClose

Event : Menu was closed by select or focus change.
signature : void method(MyGUI::MenuControl* _sender)

Parameters

  _sender | widget that called this event

Definition at line 252 of file MyGUI_MenuControl.h.

## ◆ mHideByAccept

bool MyGUI::MenuControl::mHideByAccept
| protected

Definition at line 308 of file MyGUI_MenuControl.h.

## ◆ mHideByLostKey

bool MyGUI::MenuControl::mHideByLostKey
| protected

Definition at line 312 of file MyGUI_MenuControl.h.

## ◆ mIsMenuDrop

bool MyGUI::MenuControl::mIsMenuDrop
| protected

Definition at line 311 of file MyGUI_MenuControl.h.

## ◆ mMenuDropMode

bool MyGUI::MenuControl::mMenuDropMode
| protected

Definition at line 310 of file MyGUI_MenuControl.h.

## ◆ mResizeToContent

bool MyGUI::MenuControl::mResizeToContent
| protected

Definition at line 313 of file MyGUI_MenuControl.h.

The documentation for this class was generated from the following files:

- MyGUI_MenuControl.h
- MyGUI_MenuControl.cpp